{
 TBrMenu DEMO Program
 =====================
 This component is not TMainMenu descendant, it's just Component that can Handle
 All TMainMenu options at runtime, (setting Items enabled, disabled, visible, etc.).
 The purpose of this Component is to ease the task of Assigning priviledges on
 some Menu Options to End Users. It let's the developper, though the Simple Event
 OnItemSelect, which Fires for every Items And Submenus, manage all its properties.
 Actually, I use to verify Users permissions to Access menu items At User Logon.


 Note: As Always this component is FreeWare, you run your own risks.

 Bugs, Suggestions to: jo.peralta@codetel.net.do
 =====================
 Author : Jos Bienvenido Rodrguez
 Date   : 04/12/1999
 Version : 1.0

}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, BrMenu, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Menu11: TMenuItem;
    Menu111: TMenuItem;
    Menu121: TMenuItem;
    Menu131: TMenuItem;
    Menu141: TMenuItem;
    Menu151: TMenuItem;
    N1: TMenuItem;
    Menu161: TMenuItem;
    Menu1211: TMenuItem;
    Menu1221: TMenuItem;
    Menu1231: TMenuItem;
    Menu1241: TMenuItem;
    Menu12411: TMenuItem;
    Menu12421: TMenuItem;
    Menu12431: TMenuItem;
    Menu124211: TMenuItem;
    Menu12422: TMenuItem;
    Menu1411: TMenuItem;
    Menu1421: TMenuItem;
    Menu21: TMenuItem;
    Menu211: TMenuItem;
    Menu221: TMenuItem;
    Menu231: TMenuItem;
    N2: TMenuItem;
    Menu241: TMenuItem;
    Exit1: TMenuItem;
    Menu2111: TMenuItem;
    Menu2121: TMenuItem;
    BrMenu1: TBrMenu;
    ListBox1: TListBox;
    Menu251: TMenuItem;
    ListBox2: TListBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BrMenu1ItemSelect(Sender: TObject; Item: TMenuItem);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BrMenu1.ProcessItems;
end;

procedure TForm1.BrMenu1ItemSelect(Sender: TObject; Item: TMenuItem);
Begin
  If Item.Enabled Then
     ListBox1.Items.Add(Item.Name)
  Else
    ListBox2.Items.Add(Item.Name);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
 Var Index : Integer;
     Value : String;
     MyItem : TMenuItem;
begin
  Index:=ListBox1.ItemIndex;
  If Index <> -1 Then
   Begin
     Value := ListBox1.Items[Index];
     ListBox2.Items.Add(Value);
     ListBox1.Items.Delete(Index);
     MyItem:=BrMenu1.Item(Value);
     If MyItem <> Nil Then
       MyItem.Enabled:=False;
   End;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
 Var Index : Integer;
     Value : String;
     MyItem : TMenuItem;
begin
  Index:=ListBox2.ItemIndex;
  If Index <> -1 Then
  Begin
     Value := ListBox2.Items[Index];
     ListBox1.Items.Add(Value);
     ListBox2.Items.Delete(Index);
     MyItem:=BrMenu1.Item(Value);
     If MyItem <> Nil Then
       MyItem.Enabled:=True;
  End;

end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
 Var i : Integer;
begin
  For i:=0 to ListBox2.Items.Count-1 Do
   ListBox1.Items.Add(ListBox2.Items[i]);
  ListBox2.Items.Clear;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
 Var i : Integer;
begin
  For i:=0 to ListBox1.Items.Count-1 Do
   ListBox2.Items.Add(ListBox1.Items[i]);
  ListBox1.Items.Clear;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  BrMenu1.ProcessItems;
end;

end.
